/**********************************************************************
* This is a Synthetic VIX indicator as described in the December 2007 *
* issue of "Active Trader" magazine.  The indicator is also named the *
* "Williams VIX Fix" since Larry Williams is credited with the        *
* formula's discovery.                                                *
*                                                                     *
* This indicator was coded by Matthew Ebersviller.   
 and modified by sohocool the 07/01/2011                 
 Kalenzo (bartlomiej.gorski@gmail.com) added bolinger band to this 
 indicator
 
**********************************************************************/


#property copyright "Copyright  2007, Matthew Ebersviller - mod by Kalenzo"
#property link      "mod: bartlomiej.gorski@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DodgerBlue
#property indicator_width1 1
#property indicator_color2 Red
#property indicator_width2 1
#property indicator_color3 Lime
#property indicator_width3 1

extern int VIX_Period = 22;
extern int BandsPeriod     = 20, 
           BandsDeviation  = 2, 
           BandsShift      = 0;

double VixBuffer[];
double up[],dn[];

int init() {
   string short_name;
   IndicatorBuffers(3);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,VixBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,up);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,dn);
   //SetIndexBuffer(1,TempBuffer);
   short_name="KALE_VIX("+VIX_Period+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

   SetIndexDrawBegin(0,VIX_Period);
   
   return(0);
}

int deinit()
  {
   return(0);
  }

int start()
  {
   int i, counted_bars=IndicatorCounted();
   
   if(Bars<=VIX_Period) return(0);
   
   if(counted_bars<1) {
      for(i=1;i<=VIX_Period;i++) {
         VixBuffer[Bars-i]=0.0;
      }
   }

   int limit=Bars-counted_bars;
   if (counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      VixBuffer[i]=VIX(i);
      
   for(i=0; i<limit; i++)
   {
      up[i] = iBandsOnArray(VixBuffer, 0, BandsPeriod, BandsDeviation, BandsShift, MODE_UPPER, i);    
      dn[i] = iBandsOnArray(VixBuffer, 0, BandsPeriod, BandsDeviation, BandsShift, MODE_LOWER, i);    
   }   
   return(0);
  }
//+------------------------------------------------------------------+

double VIX(int shift) {
  double highClose, vix;
  highClose = High[iHighest(NULL,0,MODE_CLOSE,VIX_Period,shift)];
  vix = -100 *(highClose - Low[shift]) / highClose ;
  return (vix);
}
  